package com.ruoyi.tc.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.tc.entity.AssetTask;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.tc.entity.request.AssetTaskPageRequest;
import com.ruoyi.tc.entity.response.AssetTaskIdResponse;
import org.springframework.data.domain.PageRequest;
import java.util.List;

/**
 * 任务主表(AssetTask)表服务接口
 *
 * @author makejava
 * @since 2024-11-18 13:23:09
 */
public interface AssetTaskService  extends IService<AssetTask> {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
   List<AssetTaskIdResponse> queryById(Integer id);

    /**
     * 分页查询
     *
     * @param assetTask 筛选条件
     * @param pageRequest      分页对象
     * @return 查询结果
     */
    Page<AssetTask> queryByPage(Page<AssetTask> assetTask, AssetTaskPageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param assetTask 实例对象
     * @return 实例对象
     */
    void insert(AssetTask assetTask);

    /**
     * 修改数据
     *
     * @param assetTask 实例对象
     * @return 实例对象
     */
    int update(AssetTask assetTask);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

}
